package com.domemusictechnology.acecomparator;


import voltage.controllers.*;
import voltage.core.*;
import voltage.core.Jack.JackType;
import voltage.sources.*;
import voltage.utility.*;
import voltage.processors.*;
import voltage.effects.*;
import java.awt.*;

//[user-imports]   Add your own imports here
//[/user-imports]


public class AceComparator extends VoltageModule
//[user-inheritance]
//[/user-inheritance]
{

public AceComparator( long moduleID, VoltageObjects voltageObjects )
{
   super( moduleID, voltageObjects, "ACE Comparator", ModuleType.ModuleType_CVProcessors, 1.0 );

   InitializeControls();


   canBeBypassed = false;
   SetSkin( "d2d9830c1ad648699bd441f1c0fa76fc" );
}

void InitializeControls()
{

   vxInJack = new VoltageAudioJack( "Vx In", "X Volts Input", this, JackType.JackType_AudioInput );
   AddComponent( vxInJack );
   vxInJack.SetWantsMouseNotifications( false );
   vxInJack.SetPosition( 22, 52 );
   vxInJack.SetSize( 25, 25 );
   vxInJack.SetSkin( "Jack Round Orange Ring" );

   textLabel1 = new VoltageLabel( "textLabel1", "textLabel1", this, "Vx In" );
   AddComponent( textLabel1 );
   textLabel1.SetWantsMouseNotifications( false );
   textLabel1.SetPosition( 21, 35 );
   textLabel1.SetSize( 27, 19 );
   textLabel1.SetEditable( false, false );
   textLabel1.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel1.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel1.SetColor( new Color( 0, 0, 0, 255 ) );
   textLabel1.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel1.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel1.SetBorderSize( 1 );
   textLabel1.SetMultiLineEdit( false );
   textLabel1.SetIsNumberEditor( false );
   textLabel1.SetNumberEditorRange( 0, 100 );
   textLabel1.SetNumberEditorInterval( 1 );
   textLabel1.SetNumberEditorUsesMouseWheel( false );
   textLabel1.SetHasCustomTextHoverColor( false );
   textLabel1.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel1.SetFont( "Verdana", 12, false, false );

   vyInJack = new VoltageAudioJack( "Vy In", "Y Volts Input", this, JackType.JackType_AudioInput );
   AddComponent( vyInJack );
   vyInJack.SetWantsMouseNotifications( false );
   vyInJack.SetPosition( 22, 97 );
   vyInJack.SetSize( 25, 25 );
   vyInJack.SetSkin( "Jack Round Orange Ring" );

   textLabel2 = new VoltageLabel( "textLabel2", "textLabel2", this, "Vy In" );
   AddComponent( textLabel2 );
   textLabel2.SetWantsMouseNotifications( false );
   textLabel2.SetPosition( 16, 80 );
   textLabel2.SetSize( 36, 19 );
   textLabel2.SetEditable( false, false );
   textLabel2.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel2.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel2.SetColor( new Color( 0, 0, 0, 255 ) );
   textLabel2.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel2.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel2.SetBorderSize( 1 );
   textLabel2.SetMultiLineEdit( false );
   textLabel2.SetIsNumberEditor( false );
   textLabel2.SetNumberEditorRange( 0, 100 );
   textLabel2.SetNumberEditorInterval( 1 );
   textLabel2.SetNumberEditorUsesMouseWheel( false );
   textLabel2.SetHasCustomTextHoverColor( false );
   textLabel2.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel2.SetFont( "Verdana", 12, false, false );

   vyOffsetKnob = new VoltageKnob( "Y Offset", "Y Offset Knob", this, -10.0, 10.0, 0.0 );
   AddComponent( vyOffsetKnob );
   vyOffsetKnob.SetWantsMouseNotifications( false );
   vyOffsetKnob.SetPosition( 13, 147 );
   vyOffsetKnob.SetSize( 44, 44 );
   vyOffsetKnob.SetSkin( "Plastic Blue" );
   vyOffsetKnob.SetRingSkin( "Solid Frost/Blue" );
   vyOffsetKnob.SetRange( -10.0, 10.0, 0.0, false, 0 );
   vyOffsetKnob.SetKnobParams( 215, 145 );
   vyOffsetKnob.DisplayValueInPercent( false );
   vyOffsetKnob.SetKnobAdjustsRing( true );

   textLabel3 = new VoltageLabel( "textLabel3", "textLabel3", this, "Vy Offset" );
   AddComponent( textLabel3 );
   textLabel3.SetWantsMouseNotifications( false );
   textLabel3.SetPosition( 7, 127 );
   textLabel3.SetSize( 56, 24 );
   textLabel3.SetEditable( false, false );
   textLabel3.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel3.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel3.SetColor( new Color( 0, 0, 0, 255 ) );
   textLabel3.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel3.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel3.SetBorderSize( 1 );
   textLabel3.SetMultiLineEdit( false );
   textLabel3.SetIsNumberEditor( false );
   textLabel3.SetNumberEditorRange( 0, 100 );
   textLabel3.SetNumberEditorInterval( 1 );
   textLabel3.SetNumberEditorUsesMouseWheel( false );
   textLabel3.SetHasCustomTextHoverColor( false );
   textLabel3.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel3.SetFont( "Verdana", 12, false, false );

   modeSwitch = new VoltageSwitch( "Mode Switch", "Under / Over", this, 1 );
   AddComponent( modeSwitch );
   modeSwitch.SetWantsMouseNotifications( false );
   modeSwitch.SetPosition( 7, 206 );
   modeSwitch.SetSize( 15, 27 );
   modeSwitch.SetSkin( "2-State Slide Vertical" );

   textLabel4 = new VoltageLabel( "textLabel4", "textLabel4", this, "Vx >= Vy" );
   AddComponent( textLabel4 );
   textLabel4.SetWantsMouseNotifications( false );
   textLabel4.SetPosition( 18, 205 );
   textLabel4.SetSize( 53, 14 );
   textLabel4.SetEditable( false, false );
   textLabel4.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel4.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel4.SetColor( new Color( 0, 0, 0, 255 ) );
   textLabel4.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel4.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel4.SetBorderSize( 1 );
   textLabel4.SetMultiLineEdit( false );
   textLabel4.SetIsNumberEditor( false );
   textLabel4.SetNumberEditorRange( 0, 100 );
   textLabel4.SetNumberEditorInterval( 1 );
   textLabel4.SetNumberEditorUsesMouseWheel( false );
   textLabel4.SetHasCustomTextHoverColor( false );
   textLabel4.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel4.SetFont( "Verdana", 10, true, false );

   textLabel5 = new VoltageLabel( "textLabel5", "textLabel5", this, "Vx <= Vy" );
   AddComponent( textLabel5 );
   textLabel5.SetWantsMouseNotifications( false );
   textLabel5.SetPosition( 17, 219 );
   textLabel5.SetSize( 55, 15 );
   textLabel5.SetEditable( false, false );
   textLabel5.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel5.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel5.SetColor( new Color( 0, 0, 0, 255 ) );
   textLabel5.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel5.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel5.SetBorderSize( 1 );
   textLabel5.SetMultiLineEdit( false );
   textLabel5.SetIsNumberEditor( false );
   textLabel5.SetNumberEditorRange( 0, 100 );
   textLabel5.SetNumberEditorInterval( 1 );
   textLabel5.SetNumberEditorUsesMouseWheel( false );
   textLabel5.SetHasCustomTextHoverColor( false );
   textLabel5.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel5.SetFont( "Verdana", 10, true, false );

   vxLimitedOutput = new VoltageAudioJack( "Vx Out", "X Limited Output", this, JackType.JackType_AudioOutput );
   AddComponent( vxLimitedOutput );
   vxLimitedOutput.SetWantsMouseNotifications( false );
   vxLimitedOutput.SetPosition( 22, 259 );
   vxLimitedOutput.SetSize( 25, 25 );
   vxLimitedOutput.SetSkin( "Jack Round Yellow Ring" );

   textLabel6 = new VoltageLabel( "textLabel6", "textLabel6", this, "Dome Music Technologies" );
   AddComponent( textLabel6 );
   textLabel6.SetWantsMouseNotifications( false );
   textLabel6.SetPosition( 11, 342 );
   textLabel6.SetSize( 50, 18 );
   textLabel6.SetEditable( false, false );
   textLabel6.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel6.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel6.SetColor( new Color( 0, 0, 0, 255 ) );
   textLabel6.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel6.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel6.SetBorderSize( 1 );
   textLabel6.SetMultiLineEdit( true );
   textLabel6.SetIsNumberEditor( false );
   textLabel6.SetNumberEditorRange( 0, 100 );
   textLabel6.SetNumberEditorInterval( 1 );
   textLabel6.SetNumberEditorUsesMouseWheel( false );
   textLabel6.SetHasCustomTextHoverColor( false );
   textLabel6.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel6.SetFont( "Verdana", 7, false, false );

   textLabel7 = new VoltageLabel( "textLabel7", "textLabel7", this, "Vx Limited" );
   AddComponent( textLabel7 );
   textLabel7.SetWantsMouseNotifications( false );
   textLabel7.SetPosition( 2, 242 );
   textLabel7.SetSize( 65, 19 );
   textLabel7.SetEditable( false, false );
   textLabel7.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel7.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel7.SetColor( new Color( 0, 0, 0, 255 ) );
   textLabel7.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel7.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel7.SetBorderSize( 1 );
   textLabel7.SetMultiLineEdit( false );
   textLabel7.SetIsNumberEditor( false );
   textLabel7.SetNumberEditorRange( 0, 100 );
   textLabel7.SetNumberEditorInterval( 1 );
   textLabel7.SetNumberEditorUsesMouseWheel( false );
   textLabel7.SetHasCustomTextHoverColor( false );
   textLabel7.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel7.SetFont( "Verdana", 12, false, false );

   overflowOutput = new VoltageAudioJack( "Overflow Out", "Overflow State", this, JackType.JackType_AudioOutput );
   AddComponent( overflowOutput );
   overflowOutput.SetWantsMouseNotifications( false );
   overflowOutput.SetPosition( 22, 307 );
   overflowOutput.SetSize( 25, 25 );
   overflowOutput.SetSkin( "Jack Round Pink Ring" );

   textLabel8 = new VoltageLabel( "textLabel8", "textLabel8", this, "Overflow" );
   AddComponent( textLabel8 );
   textLabel8.SetWantsMouseNotifications( false );
   textLabel8.SetPosition( 6, 289 );
   textLabel8.SetSize( 58, 20 );
   textLabel8.SetEditable( false, false );
   textLabel8.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel8.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel8.SetColor( new Color( 0, 0, 0, 255 ) );
   textLabel8.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel8.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel8.SetBorderSize( 1 );
   textLabel8.SetMultiLineEdit( false );
   textLabel8.SetIsNumberEditor( false );
   textLabel8.SetNumberEditorRange( 0, 100 );
   textLabel8.SetNumberEditorInterval( 1 );
   textLabel8.SetNumberEditorUsesMouseWheel( false );
   textLabel8.SetHasCustomTextHoverColor( false );
   textLabel8.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel8.SetFont( "Verdana", 12, false, false );

   overflowLED = new VoltageLED( "Overflow LED", "Overflow LED", this );
   AddComponent( overflowLED );
   overflowLED.SetWantsMouseNotifications( false );
   overflowLED.SetPosition( 50, 314 );
   overflowLED.SetSize( 11, 11 );
   overflowLED.SetSkin( "Silver Backed Red" );

   image2 = new VoltageImage( "image2", "image2", this, false );
   AddComponent( image2 );
   image2.SetWantsMouseNotifications( false );
   image2.SetPosition( 19, 2 );
   image2.SetSize( 33, 16 );
   image2.SetCurrentImage( "image image(55).png" );

   image3 = new VoltageImage( "image3", "image3", this, false );
   AddComponent( image3 );
   image3.SetWantsMouseNotifications( false );
   image3.SetPosition( 4, 18 );
   image3.SetSize( 64, 17 );
   image3.SetCurrentImage( "image image(56).png" );
}



//-------------------------------------------------------------------------------
//  public void Initialize()

//  Initialize will get called shortly after your module's constructor runs. You can use it to
//  do any initialization that the auto-generated code doesn't handle.
//-------------------------------------------------------------------------------
@Override
public void Initialize()
{
   //[user-Initialize]   Add your own initialization code here

   
   smoothYOffset.SetValue(vyOffsetKnob.GetValue());
   UpdateConnections();
   StartGuiUpdateTimer();
   

   //[/user-Initialize]
}


//-------------------------------------------------------------------------------
//  public void Destroy()

//  Destroy will get called just before your module gets deleted. You can use it to perform any
//  cleanup that's not handled automatically by Java.
//-------------------------------------------------------------------------------
@Override
public void Destroy()
{
   super.Destroy();
   //[user-Destroy]   Add your own module-getting-deleted code here

   StopGuiUpdateTimer();

   //[/user-Destroy]
}


//-------------------------------------------------------------------------------
//  public boolean Notify( VoltageComponent component, ModuleNotifications notification, double doubleValue, long longValue, int x, int y, Object object )

//  Notify will get called when various events occur - control values changing, timers firing, etc.
//-------------------------------------------------------------------------------
@Override
public boolean Notify( VoltageComponent component, ModuleNotifications notification, double doubleValue, long longValue, int x, int y, Object object )
{
   //[user-Notify]   Add your own notification handling code between this line and the notify-close comment
   switch( notification )
   {
      case Knob_Changed:   // doubleValue is the new VoltageKnob value
      {
         if (component == vyOffsetKnob)
         {
            smoothYOffset.SetValue(doubleValue);
         }
      }
      break;
   
      case Slider_Changed:   // doubleValue is the new slider value
      {
      }
      break;
   
      case Button_Changed:   // doubleValue is the new button/toggle button value
      {
      }
      break;
   
      case Switch_Changed:   // doubleValue is the new switch value
      {
      }
      break;
   
      case Jack_Connected:   // longValue is the new cable ID
      {
         UpdateConnections();      
      }
      break;
   
      case Jack_Disconnected:   // All cables have been disconnected from this jack
      {
         UpdateConnections();      
      }
      break;
   
      case GUI_Update_Timer:   // Called every 50ms (by default) if turned on
      {
         if (overflowLEDon)
         {
            overflowLED.SetValue(1.0);
         }
         else
         {
            overflowLED.SetValue(0.0);
         }
      }
      break;
   
      case Object_MouseMove:   // called when mouse is over an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_MouseLeave:  // called when mouse leaves an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_LeftButtonDown:   // called when user left-clicks on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_LeftButtonUp:   // called when user releases left mouse button on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_RightButtonDown:   // called when user releases right mouse button on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_RightButtonUp:   // called when user right-clicks on an object that receives mouse notifications
      {
      }
      break;
   
      case Object_LeftButtonDoubleClick: // called when user left-button double-clicks on an object that receives mouse notifications
      {
      }
      break;
   
      // Less common notifications:
   
      case Named_Timer:   // object contains a String with the name of the timer that has fired
      {
      }
      break;
   
      case Canvas_Painting:   // About to paint canvas.  object is a java.awt.Rectangle with painting boundaries
      {
      }
      break;
   
      case Canvas_Painted:   // Canvas painting is complete
      {
      }
      break;
   
      case Control_DragStart:    // A user has started dragging on a control that has been marked as draggable
      {
      }
      break;
   
      case Control_DragOn:       // This control has been dragged over during a drag operation. object contains the dragged object
      {
      }
      break;
   
      case Control_DragOff:      // This control has been dragged over during a drag operation. object contains the dragged object
      {
      }
      break;
   
      case Control_DragEnd:      // A user has ended their drag on a control that has been marked as draggable
      {
      }
      break;
   
      case Label_Changed:        // The text of an editable text control has changed
      {
      }
      break;
   
      case SoundPlayback_Start:   // A sound has begun playback
      {
      }
      break;
   
      case SoundPlayback_End:     // A sound has ended playback
      {
      }
      break;
   
      case Scrollbar_Position:    // longValue is the new scrollbar position
      {
      }
      break;
   
      case PolyVoices_Changed:    // longValue is the new number of poly voices
      {
      }
      break;
   
      case File_Dropped:     // 'object' is a String containing the file path
      {
      }
      break;
   
      case Preset_Loading_Start:   // called when preset loading begins
      {
      }
      break;
   
      case Preset_Loading_Finish:  // called when preset loading finishes
      {
      }
      break;
   
      case Variation_Loading_Start:    // sent when a variation is about to load
      {
      }
      break;
   
      case Variation_Loading_Finish:   // sent when a variation has just finished loading
      {
      }
      break;
   
      case Tempo_Changed:     // doubleValue is the new tempo
      {
      }
      break;
   
      case Randomized:     // called when the module's controls get randomized
      {
      }
      break;
   
      case VariationListChanged:   // sent when a variation gets added, deleted, or renamed, or the variations list gets reordered
      {
      }
      break;
   
      case Key_Press:     // sent when module has keyboard focus and a key is pressed; object is a VoltageKeyPressInfo object
      {
      }
      break;
   
      case Reset:    // sent when the module has been reset to default settings
      {
      }
      break;
   
      case Keyboard_NoteOn:   // sent when a note has been pressed on a VoltageKeyboard object. longValue is the note value ( 0-127 )
      {
      }
      break;
   
      case Keyboard_NoteOff:   // sent when a note has been released on a VoltageKeyboard object. longValue is the note value ( 0-127 )
      {
      }
      break;
   
      case Curve_Changed:   // sent when user has edited a curve's value. 'object' will be a VoltageCurve.CurveChangeNotification object.
      {
      }
      break;
   }



   return false;
   //[/user-Notify]
}


//-------------------------------------------------------------------------------
//  public void ProcessSample()

//  ProcessSample is called once per sample. Usually it's where you read
//  from input jacks, process audio, and write it to your output jacks.
//  Since ProcesssSample gets called 48,000 times per second, offload CPU-intensive operations
//  to other threads when possible and avoid calling native functions.
//-------------------------------------------------------------------------------
@Override
public void ProcessSample()
{
   //[user-ProcessSample]   Add your own process-sampling code here

   double vX;
   double vY;
   
   if (vxInConnected)
   {
      vX = vxInJack.GetValue();
   }
   else
   {
      vX = 0.0;
   }
   
   if (vyInConnected)
   {
      vY = vyInJack.GetValue() + smoothYOffset.GetSmoothValue();
   }
   else
   {
      vY = smoothYOffset.GetSmoothValue();
   }

   if (modeSwitch.GetValue() > 0.0)
   {
      // Check for Vx >= Vy
      if (vX >= vY)
      {
         overflowLEDon = true;
         if (vxLimitOutConnected)
         {
            vxLimitedOutput.SetValue(vY);
         }
         if (overflowOutConnected)
         {
            overflowOutput.SetValue(5.0);
         }
      }
      else
      {
         overflowLEDon = false;
         if (vxLimitOutConnected)
         {
            vxLimitedOutput.SetValue(vX);
         }
         if (overflowOutConnected)
         {
            overflowOutput.SetValue(0.0);
         }
      }
   }
   else
   {
      // Check for Vx <= Vy
      if (vX <= vY)
      {
         overflowLEDon = true;
         if (vxLimitOutConnected)
         {
            vxLimitedOutput.SetValue(vY);
         }
         if (overflowOutConnected)
         {
            overflowOutput.SetValue(5.0);
         }
      }
      else
      {
         overflowLEDon = false;
         if (vxLimitOutConnected)
         {
            vxLimitedOutput.SetValue(vX);
         }
         if (overflowOutConnected)
         {
            overflowOutput.SetValue(0.0);
         }
      }
   }
   //[/user-ProcessSample]
}


//-------------------------------------------------------------------------------
//  public String GetTooltipText( VoltageComponent component )

//  Gets called when a tooltip is about to display for a control. Override it if
//  you want to change what the tooltip displays - if you want a knob to work in logarithmic fashion,
//  for instance, you can translate the knob's current value to a log-based string and display it here.
//-------------------------------------------------------------------------------
@Override
public String GetTooltipText( VoltageComponent component )
{
   //[user-GetTooltipText]   Add your own code here



   return super.GetTooltipText( component );
   //[/user-GetTooltipText]
}


//-------------------------------------------------------------------------------
//  public void EditComponentValue( VoltageComponent component, double newValue, String newText )

//  Gets called after a user clicks on a tooltip and types in a new value for a control. Override this if
//  you've changed the default tooltip display (translating a linear value to logarithmic, for instance)
//  in GetTooltipText().
//-------------------------------------------------------------------------------
@Override
public void EditComponentValue( VoltageComponent component, double newValue, String newText )
{
   //[user-EditComponentValue]   Add your own code here



   //[/user-EditComponentValue]
   super.EditComponentValue( component, newValue, newText );
}


//-------------------------------------------------------------------------------
//  public void OnUndoRedo( String undoType, double newValue, Object optionalObject )

//  If you've created custom undo events via calls to CreateUndoEvent, you'll need to
//  process them in this function when they get triggered by undo/redo actions.
//-------------------------------------------------------------------------------
@Override
public void OnUndoRedo( String undoType, double newValue, Object optionalObject )
{
   //[user-OnUndoRedo]   Add your own code here



   //[/user-OnUndoRedo]
}


//-------------------------------------------------------------------------------
//  public byte[] GetStateInformation()

//  Gets called when the module's state gets saved, typically when the user saves a preset with
//  this module in it. Voltage Modular will automatically save the states of knobs, sliders, etc.,
//  but if you have any custom state information you need to save, return it from this function.
//-------------------------------------------------------------------------------
@Override
public byte[] GetStateInformation()
{
   //[user-GetStateInformation]   Add your own code here



   return null;
   //[/user-GetStateInformation]
}


//-------------------------------------------------------------------------------
//  public void SetStateInformation(byte[] stateInfo)

//  Gets called when this module's state is getting restored, typically when a user opens a preset with
//  this module in it. The stateInfo parameter will contain whatever custom data you stored in GetStateInformation().
//-------------------------------------------------------------------------------
@Override
public void SetStateInformation(byte[] stateInfo)
{
   //[user-SetStateInformation]   Add your own code here



   //[/user-SetStateInformation]
}


//-------------------------------------------------------------------------------
//  public byte[] GetStateInformationForVariations()

//  Gets called when a user saves a variation with this module in it.
//  Voltage Modular will automatically save the states of knobs, sliders, etc.,
//  but if you have any custom state information you need to save, return it from this function.
//-------------------------------------------------------------------------------
@Override
public byte[] GetStateInformationForVariations()
{
   //[user-GetStateInformationForVariations]   Add your own code here



   return GetStateInformation();
   //[/user-GetStateInformationForVariations]
}


//-------------------------------------------------------------------------------
//  public void SetStateInformationForVariations(byte[] stateInfo)

//  Gets called when a user loads a variation with this module in it.
//  The stateInfo parameter will contain whatever custom data you stored in GetStateInformationForVariations().
//-------------------------------------------------------------------------------
@Override
public void SetStateInformationForVariations(byte[] stateInfo)
{
   //[user-SetStateInformationForVariations]   Add your own code here
   SetStateInformation(stateInfo);



   //[/user-SetStateInformationForVariations]
}


// Auto-generated variables
private VoltageImage image3;
private VoltageImage image2;
private VoltageLED overflowLED;
private VoltageLabel textLabel8;
private VoltageAudioJack overflowOutput;
private VoltageLabel textLabel7;
private VoltageLabel textLabel6;
private VoltageAudioJack vxLimitedOutput;
private VoltageLabel textLabel5;
private VoltageLabel textLabel4;
private VoltageSwitch modeSwitch;
private VoltageLabel textLabel3;
private VoltageKnob vyOffsetKnob;
private VoltageLabel textLabel2;
private VoltageAudioJack vyInJack;
private VoltageLabel textLabel1;
private VoltageAudioJack vxInJack;


//[user-code-and-variables]    Add your own variables and functions here

private double vOffsetValue;
private SmoothValue smoothYOffset = new SmoothValue();

private boolean vxInConnected;
private boolean vyInConnected;
private boolean vxLimitOutConnected;
private boolean overflowOutConnected;
private boolean overflowLEDon;

private void UpdateConnections()
{
   vxInConnected = vxInJack.IsConnected();
   vyInConnected = vyInJack.IsConnected();
   vxLimitOutConnected = vxLimitedOutput.IsConnected();
   overflowOutConnected = overflowOutput.IsConnected();
   
}



//[/user-code-and-variables]
}

 